#! /usr/bin/python3
#----------------------------------------------------------------
# Dateiname: hello_oled.py
# Die aktuelle Uhrzeit wird auf dem OLED-Display angezeigt
#  
# Raspberry Pi programmieren mit Python, mitp
# Kap. 12
# Michael Weigend 20. April 2021
#----------------------------------------------------------------
import time
import adafruit_ssd1306
import busio
from board import SCL, SDA
from PIL import Image, ImageDraw, ImageFont

i2c = busio.I2C(SCL, SDA)
disp = adafruit_ssd1306.SSD1306_I2C(128, 64, i2c)
disp.fill(0)
w, h = disp.width, disp.height
image = Image.new('1', (w, h)) 
draw = ImageDraw.Draw(image)
wochentag, monat, tag, zeit, jahr  = time.asctime().split()
draw.text((20,20),  text=zeit, fill=True)
disp.image(image)
disp.show()

