#! /usr/bin/python3
#----------------------------------------------------------------
# Dateiname: oled_temp.py
# Die aktuelle Temperatur wird auf dem OLED-Display angezeigt.
# Angeschlossen ist ein DS1820 Temperatursensor.
#  
# Michael Weigend
# Raspberry Pi programmieren mit Python, 4. Auflage, mitp 2019
# Kap. 12
# Michael Weigend 20. November 2018
#----------------------------------------------------------------
import time
import adafruit_ssd1306
import busio
from board import SCL, SDA
from PIL import Image, ImageDraw, ImageFont
from temp import readTemp

FONT = "/usr/share/fonts/truetype/freefont/FreeSans.ttf"
W, H = 128, 64

i2c = busio.I2C(SCL, SDA)
disp = adafruit_ssd1306.SSD1306_I2C(128, 64, i2c)
disp.fill(0)
disp.show()

image = Image.new('1', (W, H))
draw = ImageDraw.Draw(image)
font = ImageFont.truetype(FONT, size=30)

while True:
    ppm = round(readTemp(), 1)
    text = "{} °C".format(ppm)
    draw.rectangle((0, 0, W, H), outline=0, fill=False) 
    draw.text((0,0),  text,  font=font, fill=255)
    disp.image(image)
    disp.show()
    time.sleep(1)
