#! /usr/bin/python3
#----------------------------------------------------------------
# Dateiname: oled_uhr.py
# Die aktuelle Uhrzeit wird auf dem OLED-Display angezeigt
#  
# Michael Weigend
# Raspberry Pi programmieren mit Python, mitp
# Kap. 12
# Michael Weigend 20. April 20121
#----------------------------------------------------------------
import time
import adafruit_ssd1306
import busio
from board import SCL, SDA
from PIL import Image, ImageDraw, ImageFont

i2c = busio.I2C(SCL, SDA)
disp = adafruit_ssd1306.SSD1306_I2C(128, 64, i2c)
disp.fill(0)
w, h = disp.width, disp.height
image = Image.new('1', (w, h)) 
draw = ImageDraw.Draw(image)

font = ImageFont.truetype("/usr/share/fonts/truetype/freefont/FreeSans.ttf", size=30)

while True:
    #disp.clear()
    wochentag, monat, tag, zeit, jahr  = time.asctime().split()
    draw.rectangle((0, 0, w, h),fill=False) 
    draw.text((0,0),  zeit,  font=font, fill=True)
    disp.image(image)
    disp.show()
    time.sleep(0.1)
