#----------------------------------------------------------------
# Dateiname: alkohol_messung.py
# Spannungsmessung
#
# Michael Weigend
# Raspberry Pi programmieren mit Python, 2019
# Kap. 9
# 15. April 2021
#----------------------------------------------------------------

import time
from read_mcp import readVoltage
from numpy import interp


SPANNUNG = [0.68, 2.14, 2.48, 2.73, 2.96, 3.15]   # x-Achse
ALKOHOLGEHALT = [0, 2, 4, 6, 8, 10]              # y-Achse

TEXT = "In der (unverdünnten) Lösung sind {:.2f} Volumenprozent Ethanol."
FEHLER = "Messbereich überschritten!"

while True:
    spannung = readVoltage()
    if spannung > SPANNUNG[-1]:
        print(FEHLER)
    else:
        alkoholgehalt = interp(spannung, SPANNUNG, ALKOHOLGEHALT)     
        print(TEXT.format(alkoholgehalt))      
        time.sleep(1)

