#----------------------------------------------------------------
# Dateiname: read_mcp.py
# Spannungsmessung
#
# Michael Weigend
# Raspberry Pi programmieren mit Python, mitp
# Kap. 9
# 15. April 2021
#----------------------------------------------------------------

from time import sleep
from busio import SPI
from digitalio import DigitalInOut
from board import SCLK, MISO, MOSI, D5
from adafruit_mcp3xxx.mcp3008 import MCP3008, P0
from adafruit_mcp3xxx.analog_in import AnalogIn

spi = SPI(clock=SCLK, MISO=MISO, MOSI=MOSI) 
cs = DigitalInOut(D5)  
mcp = MCP3008(spi, cs)
channel = AnalogIn (mcp, P0)        

def readVoltage():
        return channel.voltage

if __name__ == '__main__':
    while True:
        spannung = readVoltage()
        print('Spannung: {:.3} Volt'.format(spannung))
        sleep(1)
